#include<bits/stdc++.h>

using namespace std;

long long a[1000000];
long long b[1000000];
long long n;
long long m;
long long c,d;
long long res=0;

int main()
{
    ios_base::sync_with_stdio(false);
    cin >> n >> m;
    for(int i=0;i<n+1;i++)
        a[i]=i;
    for(int i=0;i<m;i++)
        cin >> b[i+1];
    for(int i=0;i<n-m+1;i++)
        for (int j=1; j<=m; j++)
            a[i + b[j]] = a[i + j];
    cin >> c;
    d=c;
    for(int i=1;i<=n;i++)
    {
        res+=d*a[i];
        res=res%998244353;
        d=c*d%998244353;
    }
    cout << res << endl;
}